diff --git a/.gitignore b/.gitignore
new file mode 100644
index 0000000..e0fa816
--- /dev/null
+++ b/.gitignore
@@ -0,0 +1 @@
+SOURCES/kmod-28.tar.xz
diff --git a/.kmod.metadata b/.kmod.metadata
new file mode 100644
index 0000000..bcf4b00
--- /dev/null
+++ b/.kmod.metadata
@@ -0,0 +1 @@
+0acec2b6aea3e6eb71f0b549b0ff0abcac5da004 SOURCES/kmod-28.tar.xz
diff --git a/SOURCES/depmod.conf.dist b/SOURCES/depmod.conf.dist
new file mode 100644
index 0000000..8513288
--- /dev/null
+++ b/SOURCES/depmod.conf.dist
@@ -0,0 +1,6 @@
+#
+# depmod.conf
+#
+
+# override default search ordering for kmod packaging
+search updates extra built-in weak-updates
diff --git a/SOURCES/weak-modules b/SOURCES/weak-modules
new file mode 100644
index 0000000..65806d0
--- /dev/null
+++ b/SOURCES/weak-modules
@@ -0,0 +1,1199 @@
+#!/bin/bash
+#
+# weak-modules - determine which modules are kABI compatible with installed
+#                kernels and set up the symlinks in /lib/*/weak-updates.
+#
+unset LANG LC_ALL LC_COLLATE
+
+tmpdir=$(mktemp -td ${0##*/}.XXXXXX)
+trap "rm -rf $tmpdir" EXIT
+unset ${!changed_modules_*} ${!changed_initramfs_*}
+
+unset BASEDIR
+unset CHECK_INITRAMFS
+weak_updates_dir_override=""
+default_initramfs_prefix="/boot" # will be combined with BASEDIR
+dracut="/usr/bin/dracut"
+depmod="/sbin/depmod"
+depmod_orig="$depmod"
+declare -a modules
+declare -A module_krels
+declare -A weak_modules_before
+
+declare -A groups
+declare -A grouped_modules
+
+# output of validate_weak_links, one iteration
+# short_name -> path
+declare -A compatible_modules
+
+# state for update_modules_for_krel (needed for add_kernel case)
+# short_name -> path
+declare -A installed_modules
+
+# doit:
+# A wrapper used whenever we're going to perform a real operation.
+doit() {
+    [ -n "$verbose" ] && echo "$@"
+    [ -n "$dry_run" ] || "$@"
+}
+
+# pr_verbose:
+# print verbose -- wrapper used to print extra messages if required
+pr_verbose() {
+    [ -n "$verbose" ] && echo "$@"
+}
+
+# pr_warning:
+# print warning
+pr_warning() {
+    echo "WARNING: $*"
+}
+
+# rpmsort: The sort in coreutils can't sort the RPM list how we want it so we
+# instead transform the list into a form it will sort correctly, then sort.
+rpmsort() {
+    local IFS=$' '
+    REVERSE=""
+    rpmlist=($(cat))
+
+    if [ "-r" == "$1" ];
+    then
+        REVERSE="-r"
+    fi
+
+    echo ${rpmlist[@]} | \
+        sed -e 's/-/../g' | \
+        sort ${REVERSE} -n -t"." -k1,1 -k2,2 -k3,3 -k4,4 -k5,5 -k6,6 -k7,7 \
+             -k8,8 -k9,9 -k10,10 | \
+        sed -e 's/\.\./-/g'
+}
+
+# krel_of_module:
+# Compute the kernel release of a module.
+krel_of_module() {
+    local module="$1"
+
+    if [ x"${module_krels[$module]+set}" = x"set" ]; then
+        # version cached in the array already
+        echo "${module_krels[$module]}"
+    elif [ -f "$module" ]; then
+        krel_of_module_modinfo "$module"
+    else
+        # Try to extract the kernel release from the path
+        # delete case, the .ko already deleted
+        set -- "${module#*/lib/modules/}"
+        echo "${1%%/*}"
+    fi
+}
+
+# krel_of_module_modinfo:
+# Fetches module version from internal module info
+krel_of_module_modinfo() {
+    local module="$1"
+    /sbin/modinfo -F vermagic "$module" | awk '{print $1}'
+}
+
+# weak_updates_dir:
+# gives the root directory for the weak-updates
+# We need some flexibility here because of dry-run.
+weak_updates_dir() {
+    local krel="$1"
+
+    if [[ -z "$weak_updates_dir_override" ]]; then
+        echo "$BASEDIR/lib/modules/$krel/weak-updates"
+    else
+        echo "$weak_updates_dir_override"
+    fi
+}
+
+# read_modules_list:
+# Read in a list of modules from standard input. Convert the filenames into
+# absolute paths and compute the kernel release for each module (either using
+# the modinfo section or through the absolute path.
+# If used with input redirect, should be used as read_module_list < input,
+# not input | read_modules_list, the latter spawns a subshell
+# and the arrays are not seen in the caller
+read_modules_list() {
+    local IFS=$'\n'
+    modules=($(cat))
+
+    for ((n = 0; n < ${#modules[@]}; n++)); do
+        if [ ${modules[n]:0:1} != '/' ]; then
+            modules[n]="$PWD/${modules[n]}"
+        fi
+        module_krels["${modules[n]}"]=$(krel_of_module ${modules[n]})
+    done
+}
+
+decompress_initramfs() {
+    local input=$1
+    local output=$2
+
+    # First, check if this is compressed at all
+    if cpio -i -t < "$input" > /dev/null 2>/dev/null; then
+        # If this archive contains a file early_cpio, it's a trick. Strip off
+        # the early cpio archive and try again.
+        if cpio -i -t < "$input" 2>/dev/null | grep -q '^early_cpio$' ; then
+            /usr/lib/dracut/skipcpio "$input" > "${tmpdir}/post_early_cpio.img"
+            decompress_initramfs "${tmpdir}/post_early_cpio.img" "$output"
+            retval="$?"
+            rm -f "${tmpdir}/post_early_cpio.img"
+            return $retval
+        fi
+
+        cp "$input" "$output"
+        return 0
+    fi
+
+    # Try gzip
+    if gzip -cd < "$input" > "$output" 2>/dev/null ; then
+        return 0
+    fi
+
+    # Next try xz
+    if xz -cd < "$input" > "$output" 2>/dev/null ; then
+        return 0
+    fi
+
+    echo "Unable to decompress $input: Unknown format" >&2
+    return 1
+}
+
+# List all module files and modprobe configuration that could require a new
+# initramfs. The current directory must be the root of the uncompressed
+# initramfs. The unsorted list of files is output to stdout.
+list_module_files() {
+    find . -iname \*.ko -o -iname '*.ko.xz' -o -iname '*.ko.gz' 2>/dev/null
+    find etc/modprobe.d usr/lib/modprobe.d -name \*.conf 2>/dev/null
+}
+
+# read_old_initramfs:
+compare_initramfs_modules() {
+    local old_initramfs=$1
+    local new_initramfs=$2
+
+    rm -rf "$tmpdir/old_initramfs"
+    rm -rf "$tmpdir/new_initramfs"
+    mkdir "$tmpdir/old_initramfs"
+    mkdir "$tmpdir/new_initramfs"
+
+    decompress_initramfs "$old_initramfs" "$tmpdir/old_initramfs.img"
+    pushd "$tmpdir/old_initramfs" >/dev/null
+    cpio -i < "$tmpdir/old_initramfs.img" 2>/dev/null
+    rm "$tmpdir/old_initramfs.img"
+    n=0; for i in `list_module_files|sort`; do
+        old_initramfs_modules[n]="$i"
+        n=$((n+1))
+    done
+    popd >/dev/null
+
+    decompress_initramfs "$new_initramfs" "$tmpdir/new_initramfs.img"
+    pushd "$tmpdir/new_initramfs" >/dev/null
+    cpio -i < "$tmpdir/new_initramfs.img" 2>/dev/null
+    rm "$tmpdir/new_initramfs.img"
+    n=0; for i in `list_module_files|sort`; do
+        new_initramfs_modules[n]="$i"
+        n=$((n+1))
+    done
+    popd >/dev/null
+
+    # Compare the length and contents of the arrays
+    if [ "${#old_initramfs_modules[@]}" == "${#new_initramfs_modules[@]}" -a \
+         "${old_initramfs_modules[*]}" == "${new_initramfs_modules[*]}" ];
+    then
+        # If the file lists are the same, compare each file to find any that changed
+        for ((n = 0; n < ${#old_initramfs_modules[@]}; n++)); do
+            if ! cmp "$tmpdir/old_initramfs/${old_initramfs_modules[n]}" \
+                     "$tmpdir/new_initramfs/${new_initramfs_modules[n]}" \
+                     >/dev/null 2>&1
+            then
+                return 1
+            fi
+        done
+    else
+        return 1
+    fi
+
+    return 0
+}
+
+# check_initramfs:
+# check and possibly also update the initramfs for changed kernels
+check_initramfs() {
+    local kernel=$1
+
+    # If there is no initramfs already we will not make one here.
+    if [ -e "$initramfs_prefix/initramfs-$kernel.img" ];
+    then
+        old_initramfs="$initramfs_prefix/initramfs-$kernel.img"
+        tmp_initramfs="$initramfs_prefix/initramfs-$kernel.tmp"
+        new_initramfs="$initramfs_prefix/initramfs-$kernel.img"
+
+        $dracut -f "$tmp_initramfs" "$kernel"
+
+        if ! compare_initramfs_modules "$old_initramfs" "$tmp_initramfs";
+        then
+            doit mv "$tmp_initramfs" "$new_initramfs"
+        else
+            rm -f "$tmp_initramfs"
+        fi
+    fi
+}
+
+usage() {
+    echo "Usage: ${0##*/} [options] {--add-modules|--remove-modules}"
+    echo "${0##*/} [options] {--add-kernel|--remove-kernel} {kernel-release}"
+    cat <<'EOF'
+--add-modules
+        Add a list of modules read from standard input. Create
+        symlinks in compatible kernel's weak-updates/ directory.
+        The list of modules is read from standard input.
+
+--remove-modules
+        Remove compatibility symlinks from weak-updates/ directories
+        for a list of modules.  The list of modules is read from
+        standard input. Note: it doesn't attempt to locate any
+        compatible modules to replace those being removed.
+
+--add-kernel
+        Add compatibility symlinks for all compatible modules to the
+        specified or running kernel.
+
+--remove-kernel
+        Remove all compatibility symlinks for the specified or current
+        kernel.
+
+--no-initramfs
+        Do not generate an initramfs.
+
+--verbose
+        Print the commands executed.
+
+--dry-run
+        Do not create/remove any files.
+EOF
+    exit $1
+}
+
+# module_has_changed:
+# Mark if an actual change occured that we need to deal with later by calling
+# depmod or mkinitramfs against the affected kernel.
+module_has_changed() {
+
+    declare module=$1 krel=$2
+    declare orig_module=$module
+
+    module=${module%.ko}
+    [[ $module == $orig_module ]] && module=${module%.ko.xz}
+    [[ $module == $orig_module ]] && module=${module%.ko.gz}
+    module=${module##*/}
+
+    eval "changed_modules_${krel//[^a-zA-Z0-9]/_}=$krel"
+    eval "changed_initramfs_${krel//[^a-zA-Z0-9]/_}=$krel"
+
+}
+
+# module_weak_link:
+# Generate a weak link path for the module.
+# Takes module file name and the target kernel release as arguments
+# The way of generation intentionally left from the initial version
+module_weak_link() {
+    local module="$1"
+    local krel="$2"
+    local module_krel
+    local subpath
+    local module_krel_escaped
+
+    module_krel="$(krel_of_module "$module")"
+    module_krel_escaped=$(echo "$module_krel" | \
+                              sed 's/\([.+?^$\/\\|()\[]\|\]\)/\\\0/g')
+    subpath=$(echo $module | sed -nre "s:$BASEDIR(/usr)?/lib/modules/$module_krel_escaped/([^/]*)/(.*):\3:p")
+
+    if [[ -z $subpath ]]; then
+        # module is not in /lib/modules/$krel?
+        # It's possible for example for Oracle ACFS compatibility check
+        # Install it with its full path as a /lib/modules subpath
+        subpath="$module"
+    fi
+
+    echo "$(weak_updates_dir $krel)/${subpath#/}"
+}
+
+# module_short_name:
+# 'basename' version purely in bash, cuts off path from the filename
+module_short_name() {
+    echo "${1##*/}"
+}
+
+#### Helper predicates
+
+# is_weak_for_module_valid:
+# Takes real module filename and target kernel as arguments.
+# Calculates weak symlink filename for the corresponding module
+# for the target kernel,
+# returns 'true' if the symlink filename is a symlink
+# and the symlink points to a readable file
+# EVEN if it points to a different filename
+is_weak_for_module_valid() {
+    local module="$1"
+    local krel="$2"
+    local weak_link
+
+    weak_link="$(module_weak_link $module $krel)"
+    [[ -L "$weak_link" ]] && [[ -r "$weak_link" ]]
+}
+
+# is_weak_link:
+# Takes a filename and a kernel release.
+# 'true' if the filename is symlink under weak-updates/ for the kernel.
+# It doesn't matter, if it's a valid symlink (points to a real file) or not.
+is_weak_link() {
+    local link="$1"
+    local krel="$2"
+
+    echo $link | grep -q "$(weak_updates_dir $krel)" || return 1
+    [[ -L $link ]]
+}
+
+# is_extra_exists:
+# Takes a module filename, the module's kernel release and target kernel release.
+# The module filename should be a real, not a symlink, filename (i.e. in extra/).
+# Returns 'true' if the same module exists for the target kernel.
+is_extra_exists() {
+    local module="$1"
+    local module_krel="$2"
+    local krel="$3"
+    local subpath="${module#*/lib/modules/$module_krel/extra/}"
+
+    [[ -f $BASEDIR/lib/modules/$krel/extra/$subpath ]]
+}
+
+is_kernel_installed() {
+    local krel="$1"
+
+    find_symvers_file "$krel" > /dev/null &&
+        find_systemmap_file "$krel" > /dev/null
+}
+
+is_empty_file() {
+    local file="$1"
+
+    [[ "$(wc -l "$file" | cut -f 1 -d ' ')" == 0 ]]
+}
+
+#### Helpers
+
+# find_modules:
+# Takes kernel release and a list of subdirectories.
+# Produces list of module files in the subdirectories for the kernel
+find_modules() {
+    local krel="$1"
+    shift
+    local dirs="$*"
+
+    for dir in $dirs; do
+        find $BASEDIR/lib/modules/$krel/$dir \
+             -name '*.ko' -o -name '*.ko.xz' -o -name '*.ko.gz' \
+             2>/dev/null
+    done
+}
+
+# find_modules_dirs:
+# Takes a list of directories.
+# Produces list of module files in the subdirectories
+find_modules_dirs() {
+    local dirs="$*"
+
+    for dir in $dirs; do
+        find $dir -name '*.ko' -o -name '*.ko.xz' -o -name '*.ko.gz' \
+             2>/dev/null
+    done
+}
+
+# find_installed_kernels:
+# Produces list of kernels, which modules are still installed
+find_installed_kernels() {
+    ls $BASEDIR/lib/modules/
+}
+
+# find_kernels_with_extra:
+# Produces list of kernels, where exists extra/ directory
+find_kernels_with_extra() {
+    local krel
+    local extra_dir
+
+    for krel in $(find_installed_kernels); do
+        extra_dir="$BASEDIR/lib/modules/$krel/extra"
+        [[ -d "$extra_dir" ]] || continue
+        echo "$krel"
+    done
+}
+
+# remove_weak_link_quiet:
+# Takes symlink filename and target kernel release.
+# Removes the symlink and the directory tree
+# if it was the last file in the tree
+remove_weak_link_quiet() {
+    local link="$1"
+    local krel="$2"
+    local subpath="${link#*$(weak_updates_dir $krel)}"
+
+    rm -f $link
+    ( cd "$(weak_updates_dir $krel)" && \
+          rmdir --parents --ignore-fail-on-non-empty "$(dirname "${subpath#/}")" 2>/dev/null )
+}
+
+# prepare_sandbox:
+# Takes kernel release, creates temporary weak-modules directory for it
+# and depmod config to operate on it.
+# Sets the global state accordingly
+
+prepare_sandbox() {
+    local krel="$1"
+    local orig_dir
+    local dir
+    local conf="$tmpdir/depmod.conf"
+
+    #directory
+    orig_dir=$(weak_updates_dir $krel)
+    dir="$tmpdir/$krel/weak-updates"
+
+    mkdir -p "$dir"
+    # the orig_dir can be empty
+    cp -R "$orig_dir"/* "$dir" 2>/dev/null
+
+    weak_updates_dir_override="$dir"
+
+    #config
+    echo "search external extra built-in weak-updates" >"$conf"
+    echo "external * $dir" >>"$conf"
+
+    depmod="$depmod_orig -C $conf"
+}
+
+# discard_installed:
+# remove installed_modules[] from modules[]
+discard_installed()
+{
+    local short_name
+
+    for m in "${!modules[@]}"; do
+        short_name="$(module_short_name "${modules[$m]}")"
+
+        [[ -z "${installed_modules[$short_name]}" ]] && continue
+
+        unset "modules[$m]"
+    done
+}
+
+# update_installed:
+# add compatible_modules[] to installed_modules[]
+update_installed()
+{
+    for m in "${!compatible_modules[@]}"; do
+        installed_modules[$m]="${compatible_modules[$m]}"
+    done
+}
+
+# finish_sandbox:
+# restore global state after sandboxing
+# copy configuration to the kernel directory if not dry run
+finish_sandbox() {
+    local krel="$1"
+    local override="$weak_updates_dir_override"
+    local wa_dir
+
+    weak_updates_dir_override=""
+    depmod="$depmod_orig"
+
+    [[ -n "$dry_run" ]] && return
+
+    wa_dir="$(weak_updates_dir $krel)"
+
+    rm -rf "$wa_dir"
+    mkdir -p "$wa_dir"
+
+    cp -R "${override}"/* "$wa_dir" 2>/dev/null
+}
+
+# Auxiliary functions to find symvers file
+make_kernel_file_names() {
+    local krel="$1"
+    local file="$2"
+    local suffix="$3"
+
+    echo "${BASEDIR}/boot/${file}-${krel}${suffix}"
+    echo "${BASEDIR}/lib/modules/${krel}/${file}${suffix}"
+}
+
+find_kernel_file() {
+    local krel="$1"
+    local file="$2"
+    local suffix="$3"
+    local print="$4"
+    local i
+
+    if [[ "$print" != "" ]]; then
+        make_kernel_file_names "$krel" "$file" "$suffix"
+        return 0
+    fi
+
+    for i in  $(make_kernel_file_names "$krel" "$file" "$suffix"); do
+        if [[ -r "$i" ]]; then
+            echo "$i"
+            return 0
+        fi
+    done
+
+    return 1
+}
+
+# find_symvers_file:
+# Since /boot/ files population process is now controlled by systemd's
+# kernel-install bash script and its plug-ins, it might be the case
+# that, while present, symvers file is not populated in /boot.
+# Let's also check for /lib/modules/$kver/symvers.gz, since that's where
+# it is populated from.
+#
+# $1 - krel
+# return - 0 if symvers file is found, 1 otherwise.
+# Prints symvers path if found, empty string otherwise.
+find_symvers_file() {
+    local krel="$1"
+    local print="$2"
+
+    find_kernel_file "$krel" symvers .gz "$print"
+}
+
+# find_systemmap_file:
+# Same as above but for System.map
+find_systemmap_file() {
+    local krel="$1"
+    local print="$2"
+    local no_suffix=""
+
+    find_kernel_file "$krel" System.map "$no_suffix" "$print"
+}
+
+#### Main logic
+
+# update_modules_for_krel:
+# Takes kernel release and "action" function name.
+# Skips kernel without symvers,
+# otherwise triggers the main logic of modules installing/removing
+# for the given kernel, which is:
+# - save current state of weak modules symlinks
+# - install/remove the symlinks for the given (via stdin) list of modules
+# - validate the state and remove invalid symlinks
+#   (for the modules, which are not compatible (became incompatible) for
+#   the given kernel)
+# - check the state after validation to produce needed messages
+#   and trigger initrd regeneration if the list changed.
+#
+update_modules_for_krel() {
+    local krel="$1"
+    local func="$2"
+    local force_update="$3"
+
+    is_kernel_installed "$krel" || return
+
+    prepare_sandbox $krel
+
+    global_link_state_save $krel
+
+    # remove already installed from modules[]
+    discard_installed
+
+    # do not run heavy validation procedure if no modules to install
+    if [[ "${#modules[@]}" -eq 0 ]]; then
+        finish_sandbox $krel
+        return
+    fi
+
+    $func $krel
+
+    if ! validate_weak_links $krel && [[ -z "$force_update" ]]; then
+        global_link_state_restore $krel
+    fi
+
+    # add compatible to installed
+    update_installed
+
+    global_link_state_announce_changes $krel
+
+    finish_sandbox $krel
+}
+
+# update_modules:
+# Common entry point for add/remove modules command
+# Takes the "action" function, the module list is supplied via stdin.
+# Reads the module list and triggers modules update for all installed
+# kernels.
+# Triggers initrd rebuild for the kernels, which modules are installed.
+update_modules() {
+    local func="$1"
+    local force_update="$2"
+    local module_krel
+    declare -a saved_modules
+
+    read_modules_list || exit 1
+    [[ ${#modules[@]} -gt 0 ]] || return
+    saved_modules=("${modules[@]}")
+
+    for krel in $(find_installed_kernels); do
+        update_modules_for_krel $krel $func $force_update
+        modules=("${saved_modules[@]}")
+        installed_modules=()
+    done
+
+    for module in "${modules[@]}"; do
+        # Module was built against this kernel, update initramfs.
+        module_krel="${module_krels[$module]}"
+        module_has_changed $module $module_krel
+    done
+}
+
+# add_weak_links:
+# Action function for the "add-modules" command
+# Takes the kernel release, where the modules are added
+# and the modules[] and module_krels[] global arrays.
+# Install symlinks for the kernel with minimal checks
+# (just filename checks, no symbol checks)
+add_weak_links() {
+    local krel="$1"
+    local module_krel
+    local weak_link
+
+    for module in "${modules[@]}"; do
+        module_krel="$(krel_of_module $module)"
+
+        case "$module" in
+            $BASEDIR/lib/modules/$krel/*)
+                # Module already installed to the current kernel
+                continue ;;
+        esac
+
+        if is_extra_exists $module $module_krel $krel; then
+            pr_verbose "found $(module_short_name $module) for $krel while installing for $module_krel, update case?"
+        fi
+
+        if is_weak_for_module_valid $module $krel; then
+            pr_verbose "weak module for $(module_short_name $module) already exists for kernel $krel, update case?"
+            # we should update initrd in update case,
+            # the change is not seen by the symlink detector
+            # (global_link_state_announce_changes())
+            module_has_changed $module $krel
+        fi
+
+        weak_link="$(module_weak_link $module $krel)"
+
+        mkdir -p "$(dirname $weak_link)"
+        ln -sf $module $weak_link
+
+    done
+}
+
+# remove_weak_links:
+# Action function for the "remove-modules" command
+# Takes the kernel release, where the modules are removed
+# and the modules[] and module_krels[] global arrays.
+# Removes symlinks from the given kernel if they are installed
+# for the modules in the list.
+remove_weak_links() {
+    local krel="$1"
+    local weak_link
+    local target
+    local module_krel
+
+    for module in "${modules[@]}"; do
+        module_krel="$(krel_of_module $module)"
+
+        weak_link="$(module_weak_link $module $krel)"
+        target="$(readlink $weak_link)"
+
+        if [[ "$module" != "$target" ]]; then
+            pr_verbose "Skipping symlink $weak_link"
+            continue
+        fi
+        # In update case the --remove-modules call is performed
+        # after --add-modules (from postuninstall).
+        # So, we shouldn't really remove the symlink in this case.
+        # But in the remove case the actual target already removed.
+        if ! is_weak_for_module_valid "$module" "$krel"; then
+            remove_weak_link_quiet "$weak_link" "$krel"
+        fi
+    done
+}
+
+# validate_weak_links:
+# Takes kernel release.
+# Checks if all the weak symlinks are suitable for the given kernel.
+# Uses depmod to perform the actual symbol checks and parses the output.
+# Since depmod internally creates the module list in the beginning of its work
+# accroding to the priority list in its configuration, but without symbol
+# check and doesn't amend the list during the check, the function runs it
+# in a loop in which it removes discovered incompatible symlinks
+#
+# Returns 0 (success) if proposal is fine or
+#         1 (false) if some incompatible symlinks were removed
+# initializes global hashmap compatible_modules with all the valid ones
+validate_weak_links() {
+    local krel="$1"
+    local basedir=${BASEDIR:+-b $BASEDIR}
+    local tmp
+    declare -A symbols
+    local is_updates_changed=1
+    local module
+    local module_krel
+    local target
+    local modpath
+    local symbol
+    local weak_link
+    # to return to caller that original proposal is not valid
+    # here 0 is true, 1 is false, since it will be the return code
+    local is_configuration_valid=0
+
+    tmp=$(mktemp -p $tmpdir)
+    compatible_modules=()
+
+    if ! [[ -e $tmpdir/symvers-$krel ]]; then
+        local symvers_path=$(find_symvers_file "$krel")
+
+        [[ -n "$symvers_path" ]] || return
+        zcat "$symvers_path" > $tmpdir/symvers-$krel
+    fi
+
+    while ((is_updates_changed)); do
+        is_updates_changed=0
+
+        # again $tmp because of subshell, see read_modules_list() comment
+        # create incompatibility report by depmod
+        # Shorcut if depmod finds a lot of incompatible modules elsewhere,
+        # we care only about weak-updates
+        $depmod $basedir -naeE $tmpdir/symvers-$krel $krel 2>&1 1>/dev/null | \
+            grep "$(weak_updates_dir $krel)" 2>/dev/null >$tmp
+        # parse it into symbols[] associative array in form a-la
+        #   symbols["/path/to/the/module"]="list of bad symbols"
+        while read line; do
+            set -- $(echo $line | awk '/needs unknown symbol/{print $3 " " $NF}')
+            modpath=$1
+            symbol=$2
+            if [[ -n "$modpath" ]]; then
+                symbols[$modpath]="${symbols[$modpath]} $symbol"
+                continue
+            fi
+
+            set -- $(echo $line | awk '/disagrees about version of symbol/{print $3 " " $NF}')
+            modpath=$1
+            symbol=$2
+            if [[ -n "$modpath" ]]; then
+                symbols[$modpath]="${symbols[$modpath]} $symbol"
+                continue
+            fi
+        done < $tmp
+
+        # loop through all the weak links from the list of incompatible
+        # modules and remove them. Skips non-weak incompatibilities
+        for modpath in "${!symbols[@]}"; do
+            is_weak_link $modpath $krel || continue
+
+            target=$(readlink $modpath)
+            module_krel=$(krel_of_module $target)
+
+            remove_weak_link_quiet "$modpath" "$krel"
+
+            pr_verbose "Module $(module_short_name $modpath) from kernel $module_krel is not compatible with kernel $krel in symbols: ${symbols[$modpath]}"
+            is_updates_changed=1
+            is_configuration_valid=1 # inversed value
+        done
+    done
+    rm -f $tmp
+
+    # this loop is just to produce verbose compatibility messages
+    # for the compatible modules
+    for module in "${modules[@]}"; do
+        is_weak_for_module_valid $module $krel || continue
+
+        weak_link="$(module_weak_link $module $krel)"
+        target="$(readlink $weak_link)"
+        module_krel=$(krel_of_module $target)
+
+        if [[ "$module" == "$target" ]]; then
+            short_name="$(module_short_name "$module")"
+            compatible_modules+=([$short_name]="$module")
+
+            pr_verbose "Module ${module##*/} from kernel $module_krel is compatible with kernel $krel"
+        fi
+    done
+    return $is_configuration_valid
+}
+
+# global_link_state_save:
+# Takes kernel release
+# Saves the given kernel's weak symlinks state into the global array
+# weak_modules_before[] for later processing
+global_link_state_save() {
+    local krel="$1"
+    local link
+    local target
+
+    weak_modules_before=()
+    for link in $(find_modules_dirs $(weak_updates_dir $krel) | xargs); do
+        target=$(readlink $link)
+        weak_modules_before[$link]=$target
+    done
+}
+
+# global_link_state_restore:
+# Takes kernel release
+# Restores the previous weak links state
+# (for example, if incompatible modules were installed)
+global_link_state_restore() {
+    local krel="$1"
+    local link
+    local target
+
+    pr_verbose "Falling back weak-modules state for kernel $krel"
+
+    ( cd "$(weak_updates_dir $krel)" 2>/dev/null && rm -rf * )
+
+    for link in "${!weak_modules_before[@]}"; do
+        target=${weak_modules_before[$link]}
+
+        mkdir -p "$(dirname $link)"
+        ln -sf $target $link
+    done
+}
+
+# global_link_state_announce_changes:
+# Takes kernel release
+# Reads the given kernel's weak symlinks state, compares to the saved,
+# triggers initrd rebuild if there were changes
+# and produces message on symlink removal
+global_link_state_announce_changes() {
+    local krel="$1"
+    local link
+    local target
+    local new_target
+    declare -A weak_modules_after
+
+    for link in $(find_modules_dirs $(weak_updates_dir $krel) | xargs); do
+        target=${weak_modules_before[$link]}
+        new_target=$(readlink $link)
+        weak_modules_after[$link]=$new_target
+
+        # report change of existing link and appearing of a new link
+        [[ "$target" == "$new_target" ]] || module_has_changed $new_target $krel
+    done
+
+    for link in "${!weak_modules_before[@]}"; do
+        target=${weak_modules_before[$link]}
+        new_target=${weak_modules_after[$link]}
+
+        # report change of existing link and disappearing of an old link
+        [[ "$target" == "$new_target" ]] && continue
+        module_has_changed $target $krel
+        [[ -n "$new_target" ]] ||
+            pr_verbose "Removing compatible module $(module_short_name $target) from kernel $krel"
+    done
+}
+
+# remove_modules:
+# Read in a list of modules from stdinput and process them for removal.
+# Parameter (noreplace) is deprecated, acts always as "noreplace".
+# There is no sense in the "replace" functionality since according
+# to the current requirements RPM will track existing of only one version
+# of extra/ module (no same extra/ modules for different kernels).
+remove_modules() {
+    update_modules remove_weak_links force_update
+}
+
+# add_modules:
+# Read in a list of modules from stdinput and process them for compatibility
+# with installed kernels under /lib/modules.
+add_modules() {
+    no_force_update=""
+
+    update_modules add_weak_links $no_force_update
+}
+
+# do_make_groups:
+# Takes tmp file which contains preprocessed modules.dep
+# output (or modules.dep)
+#
+# reads modules.dep format information from stdin
+# produces groups associative array
+# the group is a maximum subset of modules having at least a link
+#
+# more fine tuned extra filtering.
+do_make_groups()
+{
+    local tmp="$1"
+    local group_name
+    local mod
+    declare -a mods
+
+    while read i; do
+        mods=($i)
+
+        echo "${mods[0]}" |grep -q "extra/" || continue
+
+        # if the module already met, then its dependencies already counted
+        module_group="${grouped_modules[${mods[0]}]}"
+        [[ -n $module_group ]] && continue
+
+        # new group
+        group_name="${mods[0]}"
+
+        for mod in "${mods[@]}"; do
+            echo "$mod" |grep -q "extra/" || continue
+
+            # if there is already such group,
+            # it is a subset of the one being created
+            # due to depmod output
+            unset groups[$mod]
+
+            # extra space doesn't matter, since later (in add_kernel())
+            # it is expanded without quotes
+            groups[$group_name]+=" $mod"
+            grouped_modules[$mod]=$group_name
+        done
+    done < $tmp # avoid subshell
+}
+
+# filter_depmod_deps:
+# preprocess output for make_groups
+# depmod -n produces also aliases, so it cuts them off
+# also it removes colon after the first module
+cut_depmod_deps()
+{
+    awk 'BEGIN { pr = 1 } /^#/{ pr = 0 } pr == 1 {sub(":",""); print $0}'
+}
+
+# filter_extra_absoluted:
+# Takes kernel version
+# makes full path from the relative module path
+# (produced by depmod for in-kernel-dir modules)
+# filter only extra/ modules
+filter_extra_absoluted()
+{
+    local kver="$1"
+    local mod
+    declare -a mods
+
+    while read i; do
+        # skip non-extra. The check is not perfect, but ok
+        # to speed up handling in general cases
+        echo "$i" |grep -q "extra/" || continue
+
+        mods=($i)
+        for j in "${!mods[@]}"; do
+            mod="${mods[$j]}"
+
+            [[ ${mod:0:1} == "/" ]] || mod="$BASEDIR/lib/modules/$kver/$mod"
+            mods[$j]="$mod"
+        done
+        echo "${mods[@]}"
+    done
+}
+
+# make_groups:
+# takes k -- kernel version, we are installing extras from
+# prepares and feeds to do_make_groups
+# to create the module groups (global)
+make_groups()
+{
+    local k="$1"
+    local tmp2=$(mktemp -p $tmpdir)
+    local basedir=${BASEDIR:+-b $BASEDIR}
+
+    groups=()
+    grouped_modules=()
+
+    $depmod -n $basedir $k 2>/dev/null |
+        cut_depmod_deps | filter_extra_absoluted $k > $tmp2
+
+    do_make_groups $tmp2
+
+    rm -f $tmp2
+}
+
+add_kernel() {
+    local krel=${1:-$(uname -r)}
+    local tmp
+    local no_force_update=""
+    local num
+
+    tmp=$(mktemp -p $tmpdir)
+
+    if ! find_symvers_file "$krel" > /dev/null; then
+        echo "Symvers dump file is not found in" \
+             $(find_symvers_file "$krel" print) >&2
+        exit 1
+    fi
+
+    for k in $(find_kernels_with_extra | rpmsort -r); do
+        [[ "$krel" == "$k" ]] && continue
+        find_modules $k extra > $tmp
+
+        is_empty_file "$tmp" || make_groups $k
+
+        # reuse tmp
+
+	# optimization, check independent modules in one run.
+	# first try groups with one element in each.
+	# it means independent modules, so we can safely remove
+	# incompatible links
+	# some cut and paste here
+
+	echo > $tmp
+        for g in "${groups[@]}"; do
+	    num="$(echo "$g" | wc -w)"
+	    [ "$num" -gt 1 ] && continue
+
+            printf '%s\n' $g >> $tmp
+	done
+        # to avoid subshell, see the read_modules_list comment
+        read_modules_list < $tmp
+        update_modules_for_krel $krel add_weak_links force_update
+
+        for g in "${groups[@]}"; do
+	    num="$(echo "$g" | wc -w)"
+	    [ "$num" -eq 1 ] && continue
+
+            printf '%s\n' $g > $tmp
+            read_modules_list < $tmp
+            update_modules_for_krel $krel add_weak_links $no_force_update
+        done
+    done
+
+    rm -f $tmp
+
+}
+
+remove_kernel() {
+    remove_krel=${1:-$(uname -r)}
+    weak_modules="$(weak_updates_dir $remove_krel)"
+    module_has_changed $weak_modules $remove_krel
+
+    # Remove everything beneath the weak-updates directory
+    ( cd "$weak_modules" && doit rm -rf * )
+}
+
+################################################################################
+################################## MAIN GUTS ###################################
+################################################################################
+
+options=`getopt -o h --long help,add-modules,remove-modules \
+                     --long add-kernel,remove-kernel \
+                     --long dry-run,no-initramfs,verbose,delete-modules \
+                     --long basedir:,dracut:,check-initramfs-prog: -- "$@"`
+
+[ $? -eq 0 ] || usage 1
+
+eval set -- "$options"
+
+while :; do
+    case "$1" in
+    --add-modules)
+        do_add_modules=1
+        ;;
+    --remove-modules)
+        do_remove_modules=1
+        ;;
+    --add-kernel)
+        do_add_kernel=1
+        ;;
+    --remove-kernel)
+        do_remove_kernel=1
+        ;;
+    --dry-run)
+        dry_run=1
+        # --dry-run option is not pure dry run anymore,
+        # because of depmod used internally.
+        # For add/remove modules we have to add/remove the symlinks
+        # and just restore the original configuration afterwards.
+        ;;
+    --no-initramfs)
+        no_initramfs=1
+        ;;
+    --verbose)
+        verbose=1
+        ;;
+    --delete-modules)
+        pr_warning "--delete-modules is deprecated, no effect"
+        ;;
+    --basedir)
+        BASEDIR="$2"
+        shift
+        ;;
+    --dracut)
+        dracut="$2"
+        shift
+        ;;
+    --check-initramfs-prog)
+        CHECK_INITRAMFS="$2"
+        shift
+        ;;
+    -h|--help)
+        usage 0
+        ;;
+    --)
+        shift
+        break
+        ;;
+    esac
+    shift
+done
+
+if [ ! -x "$dracut" ]
+then
+    echo "weak-modules: could not find dracut at $dracut"
+    exit 1
+fi
+
+initramfs_prefix="$BASEDIR/${default_initramfs_prefix#/}"
+
+if [ -n "$do_add_modules" ]; then
+    add_modules
+
+elif [ -n "$do_remove_modules" ]; then
+    remove_modules
+
+elif [ -n "$do_add_kernel" ]; then
+    kernel=${1:-$(uname -r)}
+    add_kernel $kernel
+
+elif [ -n "$do_remove_kernel" ]; then
+    kernel=${1:-$(uname -r)}
+    remove_kernel $kernel
+
+    exit 0
+else
+    usage 1
+fi
+
+################################################################################
+###################### CLEANUP POST ADD/REMOVE MODULE/KERNEL ###################
+################################################################################
+
+# run depmod and dracut as needed
+for krel in ${!changed_modules_*}; do
+    krel=${!krel}
+    basedir=${BASEDIR:+-b $BASEDIR}
+
+    if is_kernel_installed $krel; then
+        doit $depmod $basedir -ae -F $(find_systemmap_file $krel) $krel
+    else
+        pr_verbose "Skipping depmod for non-installed kernel $krel"
+    fi
+done
+
+for krel in ${!changed_initramfs_*}; do
+    krel=${!krel}
+
+    if [ ! -n "$no_initramfs" ]; then
+        ${CHECK_INITRAMFS:-check_initramfs} $krel
+    fi
+done
diff --git a/SPECS/kmod.spec b/SPECS/kmod.spec
new file mode 100644
index 0000000..a8b902b
--- /dev/null
+++ b/SPECS/kmod.spec
@@ -0,0 +1,351 @@
+Name:		kmod
+Version:	28
+Release:	7%{?dist}
+Summary:	Linux kernel module management utilities
+
+License:	GPLv2+
+URL:		https://git.kernel.org/pub/scm/utils/kernel/kmod/kmod.git
+Source0:	https://www.kernel.org/pub/linux/utils/kernel/kmod/%{name}-%{version}.tar.xz
+Source1:	weak-modules
+Source2:	depmod.conf.dist
+Exclusiveos:	Linux
+
+BuildRequires:  gcc
+BuildRequires:	chrpath
+BuildRequires:	zlib-devel
+BuildRequires:	xz-devel
+BuildRequires:  libxslt
+BuildRequires:  openssl-devel
+BuildRequires:  make
+BuildRequires:  libzstd-devel
+
+Provides:	module-init-tools = 4.0-1
+Obsoletes:	module-init-tools < 4.0-1
+Provides:	/sbin/modprobe
+
+%description
+The kmod package provides various programs needed for automatic
+loading and unloading of modules under 2.6, 3.x, and later kernels, as well
+as other module management programs. Device drivers and filesystems are two
+examples of loaded and unloaded modules.
+
+%package libs
+Summary:	Libraries to handle kernel module loading and unloading
+License:	LGPLv2+
+
+%description libs
+The kmod-libs package provides runtime libraries for any application that
+wishes to load or unload Linux kernel modules from the running system.
+
+%package devel
+Summary:	Header files for kmod development
+Requires:	%{name}-libs%{?_isa} = %{version}-%{release}
+
+%description devel
+The kmod-devel package provides header files used for development of
+applications that wish to load or unload Linux kernel modules.
+
+%prep
+%autosetup -p1
+
+%build
+%configure \
+  --with-openssl \
+  --with-zlib \
+  --with-xz \
+  --with-zstd
+
+%{make_build} V=1
+
+%install
+%{make_install}
+
+pushd $RPM_BUILD_ROOT%{_mandir}/man5
+ln -s modprobe.d.5.gz modprobe.conf.5.gz
+popd
+
+find %{buildroot} -type f -name "*.la" -delete
+
+mkdir -p $RPM_BUILD_ROOT%{_sbindir}
+ln -sf ../bin/kmod $RPM_BUILD_ROOT%{_sbindir}/modprobe
+ln -sf ../bin/kmod $RPM_BUILD_ROOT%{_sbindir}/modinfo
+ln -sf ../bin/kmod $RPM_BUILD_ROOT%{_sbindir}/insmod
+ln -sf ../bin/kmod $RPM_BUILD_ROOT%{_sbindir}/rmmod
+ln -sf ../bin/kmod $RPM_BUILD_ROOT%{_sbindir}/depmod
+ln -sf ../bin/kmod $RPM_BUILD_ROOT%{_sbindir}/lsmod
+
+mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d
+mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/depmod.d
+mkdir -p $RPM_BUILD_ROOT%{_prefix}/lib/modprobe.d
+
+install -pm 755 %{SOURCE1} $RPM_BUILD_ROOT%{_sbindir}/weak-modules
+install -m 0644 %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/depmod.d/dist.conf
+
+%files
+%dir %{_sysconfdir}/depmod.d
+%dir %{_sysconfdir}/modprobe.d
+%dir %{_prefix}/lib/modprobe.d
+%{_bindir}/kmod
+%{_sbindir}/modprobe
+%{_sbindir}/modinfo
+%{_sbindir}/insmod
+%{_sbindir}/rmmod
+%{_sbindir}/lsmod
+%{_sbindir}/depmod
+%{_sbindir}/weak-modules
+%{_datadir}/bash-completion/
+%{_sysconfdir}/depmod.d/dist.conf
+%attr(0644,root,root) %{_mandir}/man5/*.5*
+%attr(0644,root,root) %{_mandir}/man8/*.8*
+%doc NEWS README TODO
+
+%files libs
+%license COPYING
+%{_libdir}/libkmod.so.*
+
+%files devel
+%{_includedir}/libkmod.h
+%{_libdir}/pkgconfig/libkmod.pc
+%{_libdir}/libkmod.so
+
+%changelog
+* Thu Oct 21 2021 Yauheni Kaliuta <ykaliuta@redhat.com> - 28-7
+- Add RHEL gating configuration. Related: rhbz#1985100
+
+* Tue Aug 10 2021 Yauheni Kaliuta <ykaliuta@redhat.com> - 28-6
+- add default config.
+  Resolves: rhbz#1985100
+
+* Mon Aug 09 2021 Mohan Boddu <mboddu@redhat.com> - 28-5
+- Rebuilt for IMA sigs, glibc 2.34, aarch64 flags
+  Related: rhbz#1991688
+
+* Wed Jun 16 2021 Mohan Boddu <mboddu@redhat.com> - 28-4
+- Rebuilt for RHEL 9 BETA for openssl 3.0
+  Related: rhbz#1971065
+
+* Fri Apr 16 2021 Mohan Boddu <mboddu@redhat.com> - 28-3
+- Rebuilt for RHEL 9 BETA on Apr 15th 2021. Related: rhbz#1947937
+
+* Tue Jan 26 2021 Fedora Release Engineering <releng@fedoraproject.org> - 28-2
+- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild
+
+* Thu Jan 07 2021 Josh Boyer <jwboyer@fedoraproject.org> - 28-1
+- New upstream v28
+- Enable zstd support
+- Resolves: rhbz#1913949
+
+* Tue Jul 28 2020 Fedora Release Engineering <releng@fedoraproject.org> - 27-3
+- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild
+
+* Wed Mar 25 2020 Yauheni Kaliuta <ykaliuta@fedoraproject.org> - 27-2
+- add 0001-depmod-do-not-output-.bin-to-stdout.patch
+  Resolves: rhbz#1808430
+
+* Thu Feb 20 2020 Peter Robinson <pbrobinson@fedoraproject.org> - 27-1
+- New upstream v27
+
+* Mon Jan 20 2020 Yauheni Kaliuta <ykaliuta@fedoraproject.org> - 26-5
+- weak-modules: sync with RHEL
+
+* Thu Jul 25 2019 Fedora Release Engineering <releng@fedoraproject.org> - 26-4
+- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild
+
+* Mon Feb 25 2019 Yauheni Kaliuta <yauheni.kaliuta@redhat.com> - 26-3
+- weak-modules: sync with RHEL
+
+* Sun Feb 24 2019 Yauheni Kaliuta <ykaliuta@fedoraproject.org> - 26-2
+- add PKCS7/openssl support (rhbz 1320921)
+
+* Sun Feb 24 2019 Yauheni Kaliuta <ykaliuta@fedoraproject.org> - 26-1
+- Update to version 26 (rhbz 1673749)
+
+* Fri Feb 01 2019 Fedora Release Engineering <releng@fedoraproject.org> - 25-5
+- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild
+
+* Mon Oct 29 2018 James Antill <james.antill@redhat.com> - 25-4
+- Remove ldconfig scriptlet, now done via. transfiletrigger in glibc (rhbz 1644063)
+
+* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 25-3
+- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild
+
+* Wed Feb 07 2018 Fedora Release Engineering <releng@fedoraproject.org> - 25-2
+- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild
+
+* Tue Jan 09 2018 Josh Boyer <jwboyer@fedoraproject.org> - 25-1
+- Update to version 25 (rhbz 1532597)
+
+* Thu Aug 03 2017 Fedora Release Engineering <releng@fedoraproject.org> - 24-3
+- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Binutils_Mass_Rebuild
+
+* Wed Jul 26 2017 Fedora Release Engineering <releng@fedoraproject.org> - 24-2
+- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild
+
+* Fri Feb 24 2017 Josh Boyer <jwboyer@fedoraproject.org> - 24-1
+- Update to version 24 (rhbz 1426589)
+
+* Fri Feb 10 2017 Fedora Release Engineering <releng@fedoraproject.org> - 23-3
+- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild
+
+* Fri Jul 22 2016 Josh Boyer <jwboyer@fedoraproject.org> - 23-1
+- Update to version 23
+
+* Thu Feb 25 2016 Peter Robinson <pbrobinson@fedoraproject.org> 22-4
+- Add powerpc patch to fix ToC on 4.5 ppc64le kernel
+
+* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 22-3
+- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild
+
+* Thu Jan 07 2016 Josh Boyer <jwboyer@fedoraproject.org> - 22-2
+- Fix path to dracut in weak-modules (rhbz 1295038)
+
+* Wed Nov 18 2015 Josh Boyer <jwboyer@fedoraproject.org> - 22-1
+- Update to version 22
+
+* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 21-3
+- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild
+
+* Mon Jun 15 2015 Ville Skyttä <ville.skytta@iki.fi> - 21-2
+- Own bash completion dirs not owned by anything in dep chain
+
+* Tue Jun 09 2015 Josh Boyer <jwboyer@fedoraproject.org> - 21-1
+- Update to verion 21
+
+* Mon Mar 02 2015 Josh Boyer <jwboyer@fedoraproject.org> - 20.1
+- Update to version 20
+
+* Sat Feb 21 2015 Till Maas <opensource@till.name> - 19-2
+- Rebuilt for Fedora 23 Change
+  https://fedoraproject.org/wiki/Changes/Harden_all_packages_with_position-independent_code
+
+* Sun Nov 16 2014 Josh Boyer <jwboyer@fedoraproject.org> - 19-1
+- Update to version 19
+
+* Wed Oct 29 2014 Josh Boyer <jwboyer@fedoraproject.org> - 18-4
+- Backport patch to fix device node permissions (rhbz 1147248)
+
+* Sun Aug 17 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 18-3
+- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild
+
+* Sat Jul 12 2014 Tom Callaway <spot@fedoraproject.org> - 18-2
+- fix license handling
+
+* Tue Jun 24 2014 Josh Boyer <jwboyer@fedoraproject.org> - 18-1
+- Update to version 18
+
+* Sun Jun 08 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 17-2
+- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild
+
+* Wed Apr 09 2014 Josh Boyer <jwboyer@fedoraproject.org> - 17-1
+- Update to version 17
+
+* Thu Jan 02 2014 Václav Pavlín <vpavlin@redhat.com> - 16-1
+- Update to version 16
+
+* Thu Aug 22 2013 Josh Boyer <jwboyer@fedoraproject.org> - 15-1
+- Update to version 15
+
+* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 14-2
+- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild
+
+* Fri Jul 05 2013 Josh Boyer <jwboyer@redhat.com> - 14-1
+- Update to version 14
+
+* Fri Apr 19 2013 Václav Pavlín <vpavlin@redhat.com> - 13-2
+- Main package should require -libs
+
+* Wed Apr 10 2013 Josh Boyer <jwboyer@redhat.com> - 13-1
+- Update to version 13
+
+* Wed Mar 20 2013 Weiping Pan <wpan@redhat.com> - 12-3
+- Pull in weak-modules for kABI from Jon Masters <jcm@redhat.com> 
+
+* Mon Mar 18 2013 Josh Boyer <jwboyer@redhat.com>
+- Add patch to make rmmod understand built-in modules (rhbz 922187)
+
+* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 12-2
+- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild
+
+* Thu Dec 06 2012 Josh Boyer <jwboyer@redhat.com>
+- Update to version 12
+
+* Thu Nov 08 2012 Josh Boyer <jwboyer@redhat.com>
+- Update to version 11
+
+* Fri Sep 07 2012 Josh Boyer <jwboyer@redaht.com>
+- Update to version 10
+
+* Mon Aug 27 2012 Josh Boyer <jwboyer@redhat.com>
+- Update to version 9
+
+* Thu Jul 19 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 8-3
+- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild
+
+* Wed May 23 2012 Josh Boyer <jwboyer@redhat.com> - 8-2
+- Provide modprobe.conf(5) (rhbz 824552)
+
+* Tue May 08 2012 Josh Boyer <jwboyer@redhat.com> - 8-1
+- Update to version 8
+
+* Mon Mar 19 2012 Kay Sievers <kay@redhat.com> - 7-1
+- update to version 7
+  - fix issue with --show-depends, where built-in
+    modules of the running kernel fail to include
+    loadable modules of the kernel specified
+
+* Sun Mar 04 2012 Kay Sievers <kay@redhat.com> - 6-1
+- update to version 6
+- remove all patches, they are included in the release
+
+* Fri Feb 24 2012 Kay Sievers <kay@redhat.com> - 5-8
+- try to address brc#771285
+
+* Sun Feb 12 2012 Kay Sievers <kay@redhat.com> - 5-7
+- fix infinite loop with softdeps
+
+* Thu Feb 09 2012 Harald Hoyer <harald@redhat.com> 5-6
+- add upstream patch to fix "modprobe --ignore-install --show-depends"
+  otherwise dracut misses a lot of modules, which are already loaded
+
+* Wed Feb 08 2012 Harald Hoyer <harald@redhat.com> 5-5
+- add "lsmod"
+
+* Tue Feb  7 2012 Kay Sievers <kay@redhat.com> - 5-4
+- remove temporarily added fake-provides
+
+* Tue Feb  7 2012 Kay Sievers <kay@redhat.com> - 5-3
+- temporarily add fake-provides to be able to bootstrap
+  the new udev which pulls the old udev into the buildroot
+
+* Tue Feb  7 2012 Kay Sievers <kay@redhat.com> - 5-1
+- Update to version 5
+- replace the module-init-tools package and provide all tools
+  as compatibility symlinks
+
+* Mon Jan 16 2012 Kay Sievers <kay@redhat.com> - 4-1
+- Update to version 4
+- set --with-rootprefix=
+- enable zlib and xz support
+
+* Thu Jan 05 2012 Jon Masters <jcm@jonmasters.org> - 3-1
+- Update to latest upstream (adds new depmod replacement utility)
+- For the moment, use the "kmod" utility to test the various functions
+
+* Fri Dec 23 2011 Jon Masters <jcm@jonmasters.org> - 2-6
+- Update kmod-2-with-rootlibdir patch with rebuild automake files
+
+* Fri Dec 23 2011 Jon Masters <jcm@jonmasters.org> - 2-5
+- Initial build for Fedora following package import
+
+* Thu Dec 22 2011 Jon Masters <jcm@jonmasters.org> - 2-4
+- There is no generic macro for non-multilib "/lib", hardcode like others
+
+* Thu Dec 22 2011 Jon Masters <jcm@jonmasters.org> - 2-3
+- Update package incorporating fixes from initial review feedback
+- Cleaups to SPEC, rpath, documentation, library and binary locations
+
+* Thu Dec 22 2011 Jon Masters <jcm@jonmasters.org> - 2-2
+- Update package for posting to wider test audience (initial review submitted)
+
+* Thu Dec 22 2011 Jon Masters <jcm@jonmasters.org> - 2-1
+- Initial Fedora package for module-init-tools replacement (kmod) library